package com.develou.popup_menu

import android.os.Bundle
import android.view.MenuItem
import android.view.View
import android.widget.ImageView
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.appcompat.widget.PopupMenu

class MainActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val moreButton: ImageView = findViewById(R.id.more_actions_button)
        moreButton.setOnClickListener { view ->
            showMoreActionsMenu(view)
        }
    }

    private fun showMoreActionsMenu(button: View) {
        val popupMenu = PopupMenu(this, button)
        menuInflater.inflate(R.menu.main_menu, popupMenu.menu)
        popupMenu.setOnMenuItemClickListener (::manageItemClick)
        popupMenu.setOnDismissListener(::manageDismiss)
        popupMenu.show()
    }

    private fun manageItemClick(menuItem: MenuItem): Boolean {
        return when(menuItem.itemId){
            R.id.add_favorites, R.id.share, R.id.move-> {
                showMessage(menuItem.title)
                true
            }
            else -> false
        }
    }

    private fun manageDismiss(popupMenu: PopupMenu) {
        showMessage("Menú cerrado")
    }

    private fun showMessage(title: CharSequence) {
        Toast.makeText(this, title, Toast.LENGTH_SHORT).show()
    }
}